diff --git a/src/main/java/net/minecraft/core/net/PropertyManager.java b/src/main/java/net/minecraft/core/net/PropertyManager.java
index e2d199fe3..891935365 100644
--- a/src/main/java/net/minecraft/core/net/PropertyManager.java
+++ b/src/main/java/net/minecraft/core/net/PropertyManager.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.net;
 
-import org.apache.log4j.Logger;
+import com.mojang.logging.LogUtils;
+import org.slf4j.Logger;
 
 
 import java.io.*;
@@ -20,16 +21,16 @@ public class PropertyManager
         {
             try
             {
-                serverProperties.load(new FileInputStream(file));
+                serverProperties.load(Files.newInputStream(file.toPath()));
             }
             catch(Exception exception)
             {
-                logger.warn( (new StringBuilder()).append("Failed to load ").append(file).toString(), exception);
+                logger.warn("Failed to load " + file, exception);
                 generateNewProperties();
             }
         } else
         {
-            logger.warn( (new StringBuilder()).append(file).append(" does not exist").toString());
+            logger.warn(file + " does not exist");
             generateNewProperties();
         }
     }
@@ -105,7 +106,7 @@ public class PropertyManager
         serverProperties.setProperty(s1, s2);
     }
 
-    public static Logger logger = Logger.getLogger("Minecraft");
+    public static Logger logger = LogUtils.getLogger();
     private Properties serverProperties;
     private File serverPropertiesFile;
 
diff --git a/src/main/java/net/minecraft/core/net/SavedServerList.java b/src/main/java/net/minecraft/core/net/SavedServerList.java
index d71e5ee94..84fbeeaf3 100644
--- a/src/main/java/net/minecraft/core/net/SavedServerList.java
+++ b/src/main/java/net/minecraft/core/net/SavedServerList.java
@@ -4,6 +4,7 @@ import com.mojang.nbt.Tag;
 import com.mojang.nbt.CompoundTag;
 
 import java.io.*;
+import java.nio.file.Files;
 import java.util.ArrayList;
 import java.util.List;
 
@@ -20,7 +21,7 @@ public class SavedServerList
         serverList.serverListFile = file;
         try
         {
-            FileInputStream fileStream = new FileInputStream(file);
+            InputStream fileStream = Files.newInputStream(file.toPath());
             DataInputStream dataStream = new DataInputStream(fileStream);
             CompoundTag tag = new CompoundTag();
             tag.read(dataStream);
@@ -34,6 +35,7 @@ public class SavedServerList
             }
 
             fileStream.close();
+            dataStream.close();
         }
         catch (Exception e)
         {
@@ -47,7 +49,7 @@ public class SavedServerList
     {
         try
         {
-            FileOutputStream fileStream = new FileOutputStream(serverListFile);
+            OutputStream fileStream = Files.newOutputStream(serverListFile.toPath());
             DataOutputStream dataStream = new DataOutputStream(fileStream);
             CompoundTag tag = new CompoundTag();
 
@@ -58,6 +60,7 @@ public class SavedServerList
 
             tag.write(dataStream);
             fileStream.close();
+            dataStream.close();
         }
         catch (Exception ignored)
         {
diff --git a/src/main/java/net/minecraft/core/net/ServerData.java b/src/main/java/net/minecraft/core/net/ServerData.java
index 308fcc8de..9caef981d 100644
--- a/src/main/java/net/minecraft/core/net/ServerData.java
+++ b/src/main/java/net/minecraft/core/net/ServerData.java
@@ -1,10 +1,6 @@
 package net.minecraft.core.net;
 
 import com.mojang.nbt.CompoundTag;
-import org.apache.logging.log4j.core.jmx.Server;
-
-import java.time.LocalDateTime;
-import java.time.ZoneOffset;
 
 public class ServerData
 {
diff --git a/src/main/java/net/minecraft/core/net/command/ClientCommandHandler.java b/src/main/java/net/minecraft/core/net/command/ClientCommandHandler.java
index fd15d7c8b..2025f9f48 100644
--- a/src/main/java/net/minecraft/core/net/command/ClientCommandHandler.java
+++ b/src/main/java/net/minecraft/core/net/command/ClientCommandHandler.java
@@ -16,19 +16,19 @@ public class ClientCommandHandler implements CommandHandler{
 	}
 	
 	@Override
-	public void sendMessageToAdmins(String msg) {
+	public synchronized void sendMessageToAdmins(String msg) {
 		if(minecraft.theWorld.getLevelData().getCheatsEnabled()) {
-			minecraft.ingameGUI.addChatMessage(msg);
+			minecraft.ingameHud.addChatMessage(msg);
 		}
 	}
 
 	@Override
-	public void sendMessageToAllPlayers(String msg) {
-		minecraft.ingameGUI.addChatMessage(msg);
+	public synchronized void sendMessageToAllPlayers(String msg) {
+		minecraft.ingameHud.addChatMessage(msg);
 	}
 
 	@Override
-	public @Nullable Player getPlayer(String name) {
+	public synchronized @Nullable Player getPlayer(String name) {
 		if(minecraft.thePlayer.username.equalsIgnoreCase(name)) {
 			return minecraft.thePlayer;
 		}else {
@@ -37,24 +37,24 @@ public class ClientCommandHandler implements CommandHandler{
 	}
 
 	@Override
-	public void sendMessageToPlayer(Player player, String msg) {
+	public synchronized void sendMessageToPlayer(Player player, String msg) {
 		if(player == minecraft.thePlayer) {
-			minecraft.ingameGUI.addChatMessage(msg);
+			minecraft.ingameHud.addChatMessage(msg);
 		}
 	}
 
 	@Override
-	public boolean playerExists(String name) {
+	public synchronized boolean playerExists(String name) {
 		return name.equalsIgnoreCase(minecraft.thePlayer.username);
 	}
 
 	@Override
-	public void sendCommandFeedback(CommandSender sender, String message) {
+	public synchronized void sendCommandFeedback(CommandSender sender, String message) {
 		sender.sendMessage(message);
 	}
 	
 	@Override
-	public World getWorld(int dimension) {
+	public synchronized World getWorld(int dimension) {
 		return minecraft.theWorld;
 	}
 
diff --git a/src/main/java/net/minecraft/core/net/command/ClientPlayerCommandSender.java b/src/main/java/net/minecraft/core/net/command/ClientPlayerCommandSender.java
index 18846ffa7..404335045 100644
--- a/src/main/java/net/minecraft/core/net/command/ClientPlayerCommandSender.java
+++ b/src/main/java/net/minecraft/core/net/command/ClientPlayerCommandSender.java
@@ -24,7 +24,7 @@ public class ClientPlayerCommandSender extends PlayerCommandSender{
 
 	@Override
 	public void sendMessage(String string) {
-		minecraft.ingameGUI.addChatMessage(string);
+		minecraft.ingameHud.addChatMessage(string);
 	}
 
 	@Override
diff --git a/src/main/java/net/minecraft/core/net/command/ConsoleCommandSender.java b/src/main/java/net/minecraft/core/net/command/ConsoleCommandSender.java
index 3c6d4e34e..16eb8d552 100644
--- a/src/main/java/net/minecraft/core/net/command/ConsoleCommandSender.java
+++ b/src/main/java/net/minecraft/core/net/command/ConsoleCommandSender.java
@@ -1,9 +1,10 @@
 package net.minecraft.core.net.command;
 
-import org.apache.log4j.Logger;
+import com.mojang.logging.LogUtils;
+import net.minecraft.core.util.helper.LoggedPrintStream;
+import org.slf4j.Logger;
 
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.util.helper.LogPrintStream;
 import net.minecraft.core.world.World;
 import net.minecraft.server.MinecraftServer;
 
@@ -11,7 +12,7 @@ public class ConsoleCommandSender implements CommandSender{
 	
 	public final MinecraftServer minecraftServer;
 	
-	private static final Logger logger = Logger.getLogger("Minecraft");
+	private static final Logger LOGGER = LogUtils.getLogger();
 	
 	public ConsoleCommandSender(MinecraftServer minecraftServer) {
 		this.minecraftServer = minecraftServer;
@@ -29,7 +30,7 @@ public class ConsoleCommandSender implements CommandSender{
 
 	@Override
 	public void sendMessage(String string) {
-		logger.info(LogPrintStream.removeColorCodes(string));
+		LOGGER.info(LoggedPrintStream.removeColorCodes(string));
 	}
 
 	@Override
diff --git a/src/main/java/net/minecraft/core/net/command/ServerCommand.java b/src/main/java/net/minecraft/core/net/command/ServerCommand.java
index f9cc29a89..7a7f80b14 100644
--- a/src/main/java/net/minecraft/core/net/command/ServerCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/ServerCommand.java
@@ -16,7 +16,7 @@ public abstract class ServerCommand extends Command{
 	{
 		String formattedMessage = name + TextFormatting.LIGHT_GRAY +  ": " + message;
 		server.playerList.sendChatMessageToAllOps(TextFormatting.LIGHT_GRAY + "(" + formattedMessage + ")");
-		MinecraftServer.logger.info(formattedMessage);
+		MinecraftServer.LOGGER.info(formattedMessage);
 	}
 
 }
diff --git a/src/main/java/net/minecraft/core/net/command/ServerCommandHandler.java b/src/main/java/net/minecraft/core/net/command/ServerCommandHandler.java
index c9b8f8800..b147a3fe5 100644
--- a/src/main/java/net/minecraft/core/net/command/ServerCommandHandler.java
+++ b/src/main/java/net/minecraft/core/net/command/ServerCommandHandler.java
@@ -16,49 +16,49 @@ public class ServerCommandHandler implements CommandHandler{
 	}
 	
 	@Override
-	public void sendMessageToAdmins(String msg) {
+	public synchronized void sendMessageToAdmins(String msg) {
 		minecraftServer.playerList.sendChatMessageToAllOps(msg);
 	}
 
 	@Override
-	public @Nullable Player getPlayer(String name) {
+	public synchronized @Nullable Player getPlayer(String name) {
 		return minecraftServer.playerList.getPlayerEntity(name);
 	}
 
 	@Override
-	public void sendMessageToAllPlayers(String msg) {
+	public synchronized void sendMessageToAllPlayers(String msg) {
 		minecraftServer.playerList.sendEncryptedChatToAllPlayers(msg);
 	}
 
 	@Override
-	public void sendMessageToPlayer(Player player, String messsage) {
+	public synchronized void sendMessageToPlayer(Player player, String messsage) {
 		minecraftServer.playerList.sendPacketToPlayer(player.username, new ChatPacket(messsage, AES.keyChain.get(player.username)));
 	}
 
 	@Override
-	public boolean playerExists(String name) {
+	public synchronized boolean playerExists(String name) {
 		return minecraftServer.playerList.getPlayerEntity(name) != null;
 	}
 
 	@Override
-	public void sendCommandFeedback(CommandSender sender, String message) {
+	public synchronized void sendCommandFeedback(CommandSender sender, String message) {
 		sender.sendMessage(message);
 		
 		String message2 = "\2477" + sender.getName() + ": " + message;
 		
 		for(Player p : minecraftServer.playerList.playerEntities) {
-			if(minecraftServer.playerList.isOp(p.username)) {
+			if(minecraftServer.playerList.isOp(p.uuid)) {
 				if(sender.getPlayer() == null || sender.getPlayer() != p) {
 					sendMessageToPlayer(p, message2);
 				}
 			}
 		}
 		
-		minecraftServer.log(message2);
+		minecraftServer.logInfo(message2);
 	}
 
 	@Override
-	public World getWorld(int dimension) {
+	public synchronized World getWorld(int dimension) {
 		return minecraftServer.getDimensionWorld(dimension);
 	}
 
diff --git a/src/main/java/net/minecraft/core/net/command/ServerPlayerCommandSender.java b/src/main/java/net/minecraft/core/net/command/ServerPlayerCommandSender.java
index 88b6cbfb7..623468b23 100644
--- a/src/main/java/net/minecraft/core/net/command/ServerPlayerCommandSender.java
+++ b/src/main/java/net/minecraft/core/net/command/ServerPlayerCommandSender.java
@@ -19,7 +19,7 @@ public class ServerPlayerCommandSender extends PlayerCommandSender{
 
 	@Override
 	public boolean isAdmin() {
-		return server.playerList.isOp(player.username);
+		return server.playerList.isOp(player.uuid);
 	}
 
 	@Override
diff --git a/src/main/java/net/minecraft/core/net/command/commands/GenerateCommand.java b/src/main/java/net/minecraft/core/net/command/commands/GenerateCommand.java
index 77dade245..c7a655604 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/GenerateCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/GenerateCommand.java
@@ -1,6 +1,8 @@
 package net.minecraft.core.net.command.commands;
 
 import com.b100.utils.Utils;
+import com.mojang.logging.LogUtils;
+import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.net.command.Command;
@@ -12,6 +14,7 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.ReflectionHelper;
 import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
 import net.minecraft.core.world.generate.feature.WorldFeature;
+import org.slf4j.Logger;
 
 import java.lang.reflect.Constructor;
 import java.lang.reflect.Parameter;
@@ -24,8 +27,8 @@ import java.util.Random;
 import java.util.Set;
 
 public class GenerateCommand extends Command {
-	
-	private static Map<String, Class<? extends WorldFeature>> worldFeatures = new HashMap<>();
+	private static final Logger LOGGER = LogUtils.getLogger();
+	private static final Map<String, Class<? extends WorldFeature>> worldFeatures = new HashMap<>();
 
 	public GenerateCommand() {
 		super("generate", "gen");
@@ -173,7 +176,7 @@ public class GenerateCommand extends Command {
 				}
 			}
 		} catch (Exception e) {
-			e.printStackTrace();
+			LOGGER.error("Reflection hacking WorldFeatures failed!", e);
 		}
 	}
 }
diff --git a/src/main/java/net/minecraft/core/net/command/commands/PlaySoundCommand.java b/src/main/java/net/minecraft/core/net/command/commands/PlaySoundCommand.java
index 4f0997f3d..eb0586d4f 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/PlaySoundCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/PlaySoundCommand.java
@@ -10,6 +10,8 @@ import net.minecraft.core.net.packet.PlaySoundEffectDirectPacket;
 import net.minecraft.core.sound.SoundTypes;
 import net.minecraft.core.sound.SoundCategory;
 
+import java.util.Locale;
+
 public class PlaySoundCommand extends Command {
     public PlaySoundCommand() {
         super("playsound", "play");
@@ -33,7 +35,7 @@ public class PlaySoundCommand extends Command {
         float pitch = 1f;
         if (args.length >= 2){
             soundPath = args[0];
-            soundType = SoundCategory.valueOf(args[1]);
+            soundType = SoundCategory.valueOf(args[1].toUpperCase(Locale.ROOT));
             if (args.length >= 5){
                 x = Float.parseFloat(args[2]);
                 y = Float.parseFloat(args[3]);
@@ -45,11 +47,11 @@ public class PlaySoundCommand extends Command {
             }
         }
         if (soundPath != null && x != null){
-        	int soundId = SoundTypes.getSoundId(soundPath);
-        	if(soundId < 0) {
-        		throw new CommandError("Invalid Sound: '" + soundPath + "'!");
-        	}
             if (handler instanceof ServerCommandHandler){
+                int soundId = SoundTypes.getSoundId(soundPath);
+                if(soundId < 0) {
+                    throw new CommandError("Invalid Sound: '" + soundPath + "'!");
+                }
                 ((ServerCommandHandler) handler).minecraftServer.playerList.sendPacketToPlayersAroundPoint(x, y,z, 128f, dimension, new PlaySoundEffectDirectPacket(soundId, soundType, x, y, z, volume, pitch));
             } else if (handler instanceof ClientCommandHandler){
                 ((ClientCommandHandler) handler).minecraft.sndManager.playSoundAt(soundPath, soundType, x, y, z, volume, pitch);
diff --git a/src/main/java/net/minecraft/core/net/command/commands/SummonCommand.java b/src/main/java/net/minecraft/core/net/command/commands/SummonCommand.java
index a931a08ee..05aadab7b 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/SummonCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/SummonCommand.java
@@ -2,6 +2,7 @@ package net.minecraft.core.net.command.commands;
 
 import java.util.Set;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.world.World;
@@ -12,9 +13,11 @@ import net.minecraft.core.net.command.CommandHandler;
 import net.minecraft.core.net.command.CommandSender;
 import net.minecraft.core.net.command.LocationTarget;
 import net.minecraft.core.net.command.PlayerCommandSender;
+import org.jetbrains.annotations.NotNull;
+import org.slf4j.Logger;
 
 public class SummonCommand extends Command{
-
+	private static final Logger LOGGER = LogUtils.getLogger();
 	public SummonCommand() {
 		super("summon");
 	}
@@ -94,11 +97,11 @@ public class SummonCommand extends Command{
 		}
 	}
 	
-	public static Entity createEntity(Class<? extends Entity> entityClass, World world) {
+	public static Entity createEntity(@NotNull Class<? extends Entity> entityClass, World world) {
 		try {
 			return entityClass.getConstructor(World.class).newInstance(world);
 		}catch (Exception e) {
-			e.printStackTrace();
+            LOGGER.warn("Could not create Entity for class '{}'!", entityClass.getSimpleName());
 			throw new CommandError("Could not create Entity!");
 		}
 	}
diff --git a/src/main/java/net/minecraft/core/net/command/commands/TeleportCommand.java b/src/main/java/net/minecraft/core/net/command/commands/TeleportCommand.java
index f60a7f9dd..5f6db4c01 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/TeleportCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/TeleportCommand.java
@@ -1,5 +1,7 @@
 package net.minecraft.core.net.command.commands;
 
+import com.mojang.logging.LogUtils;
+import net.minecraft.core.Global;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.server.entity.player.ServerPlayer;
@@ -10,18 +12,19 @@ import net.minecraft.core.net.command.CommandHandler;
 import net.minecraft.core.net.command.CommandSender;
 import net.minecraft.core.net.command.PlayerCommandSender;
 import net.minecraft.core.net.command.ServerCommandHandler;
+import org.slf4j.Logger;
 
 public class TeleportCommand extends Command{
-	
+	private static final Logger LOGGER = LogUtils.getLogger();
 	public TeleportCommand() {
 		super("tp");
 	}
 
 	@Override
 	public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
-		System.out.println("TP Command");
-		System.out.println("handler: "+handler);
-		System.out.println("sender: "+sender);
+		LOGGER.info("TP Command");
+        LOGGER.info("handler: {}", handler);
+        LOGGER.info("sender: {}", sender);
 		
 		boolean sentByPlayer = sender instanceof PlayerCommandSender;
 		
diff --git a/src/main/java/net/minecraft/core/net/command/servercommands/BanCommand.java b/src/main/java/net/minecraft/core/net/command/servercommands/BanCommand.java
index d4c04e74a..da7a5e8bf 100644
--- a/src/main/java/net/minecraft/core/net/command/servercommands/BanCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/servercommands/BanCommand.java
@@ -1,9 +1,9 @@
 package net.minecraft.core.net.command.servercommands;
 
-import net.minecraft.client.entity.player.RemotePlayer;
 import net.minecraft.core.net.command.CommandHandler;
 import net.minecraft.core.net.command.CommandSender;
 import net.minecraft.core.net.command.ServerCommand;
+import net.minecraft.core.util.helper.UUIDHelper;
 import net.minecraft.server.MinecraftServer;
 import net.minecraft.server.entity.player.ServerPlayer;
 
@@ -19,14 +19,21 @@ public class BanCommand extends ServerCommand {
 
         String nameToBan = args[0];
 
-        server.playerList.banPlayer(nameToBan);
-        sendNoticeToOps(senderName, "Banning " + nameToBan);
+
         ServerPlayer player = server.playerList.getPlayerEntity(nameToBan);
-        if(player != null)
-        {
+        if(player != null) {
+            server.playerList.banPlayer(player.uuid);
+            sendNoticeToOps(senderName, "Banning " + nameToBan);
             player.playerNetServerHandler.kickPlayer("Banned by admin");
+        } else {
+            UUIDHelper.runConversionAction(nameToBan, (uuid) -> {
+                server.playerList.banPlayer(uuid);
+                sendNoticeToOps(senderName, "Banning " + nameToBan);
+            }, (username) -> handler.sendCommandFeedback(sender,"Could not retrieve UUID of player '" + username + "'"));
         }
 
+
+
         return true;
     }
 
diff --git a/src/main/java/net/minecraft/core/net/command/servercommands/ColorCommand.java b/src/main/java/net/minecraft/core/net/command/servercommands/ColorCommand.java
index 5c11a6ea7..8fd585dbd 100644
--- a/src/main/java/net/minecraft/core/net/command/servercommands/ColorCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/servercommands/ColorCommand.java
@@ -57,7 +57,7 @@ public class ColorCommand extends ServerCommand {
 		newColor = (byte) color.id;
 		player.chatColor = newColor;
 		player.hadNicknameSet = true;
-		player.mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.score, newColor, true, player.isOperator()));
+		player.mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.uuid, player.score, newColor, true, player.isOperator()));
 		sender.sendMessage(TextFormatting.LIGHT_GRAY + "You changed your color to " + color + color.getNames()[0]);
 		return true;
 	}
diff --git a/src/main/java/net/minecraft/core/net/command/servercommands/DeopCommand.java b/src/main/java/net/minecraft/core/net/command/servercommands/DeopCommand.java
index 282120958..e37bc3777 100644
--- a/src/main/java/net/minecraft/core/net/command/servercommands/DeopCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/servercommands/DeopCommand.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.net.command.servercommands;
 
+import net.minecraft.core.util.helper.UUIDHelper;
 import net.minecraft.server.MinecraftServer;
 import net.minecraft.server.entity.player.ServerPlayer;
 import net.minecraft.core.net.packet.UpdatePlayerProfilePacket;
@@ -19,18 +20,25 @@ public class DeopCommand extends ServerCommand{
 		if(args.length == 0) return false;
 		String name = args[0];
 
-		boolean playerWasOp = server.playerList.isOp(name);
-
-		server.playerList.deopPlayer(name);
-
-		if (playerWasOp) {
-			handler.sendCommandFeedback(sender, "De-opping "+name);
-		}
-
 		ServerPlayer player = (ServerPlayer) handler.getPlayer(name);
-		if(player != null && playerWasOp) {
-			handler.sendMessageToPlayer(player, TextFormatting.YELLOW + "You are no longer op!");
-			player.mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.score, player.chatColor, true, player.isOperator()));
+		if(player != null) {
+			boolean wasOp = player.isOperator();
+
+			server.playerList.deopPlayer(player.uuid);
+			if (wasOp) {
+				handler.sendCommandFeedback(sender, "De-opping " + name);
+				handler.sendMessageToPlayer(player, TextFormatting.YELLOW + "You are no longer op!");
+				player.mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator()));
+			}
+		} else {
+			UUIDHelper.runConversionAction(name, (uuid) -> {
+				if (server.playerList.isOp(uuid)) {
+					server.playerList.deopPlayer(uuid);
+					handler.sendCommandFeedback(sender, "De-opping " + name);
+				} else {
+					handler.sendCommandFeedback(sender, name + " was not an operator");
+				}
+			}, (username) -> handler.sendCommandFeedback(sender,"Could not retrieve UUID of player '" + username + "'"));
 		}
 		
 		return true;
diff --git a/src/main/java/net/minecraft/core/net/command/servercommands/KickCommand.java b/src/main/java/net/minecraft/core/net/command/servercommands/KickCommand.java
index 7613689a8..361692a6c 100644
--- a/src/main/java/net/minecraft/core/net/command/servercommands/KickCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/servercommands/KickCommand.java
@@ -33,7 +33,7 @@ public class KickCommand extends ServerCommand {
             sendNoticeToOps(senderName, "Kicking " + playerToKick.getDisplayName());
         } else
         {
-            server.log("Can't find user " + nameToKick + ". No kick attempted.");
+            server.logInfo("Can't find user " + nameToKick + ". No kick attempted.");
         }
         return true;
     }
diff --git a/src/main/java/net/minecraft/core/net/command/servercommands/NicknameCommand.java b/src/main/java/net/minecraft/core/net/command/servercommands/NicknameCommand.java
index e95b3881e..fa3577ee9 100644
--- a/src/main/java/net/minecraft/core/net/command/servercommands/NicknameCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/servercommands/NicknameCommand.java
@@ -34,7 +34,7 @@ public class NicknameCommand extends ServerCommand
 
             player.nickname = enteredNickname;
             player.hadNicknameSet = true;
-            player.mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.score, player.chatColor, true, player.isOperator()));
+            player.mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator()));
             sender.sendMessage("You set your nickname to " + player.getDisplayName());
             return true;
         }
@@ -51,7 +51,7 @@ public class NicknameCommand extends ServerCommand
             if (args.length != 1) return false;
             player.nickname = "";
             player.hadNicknameSet = true;
-            player.mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.score, player.chatColor, true, player.isOperator()));
+            player.mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator()));
             sender.sendMessage("You cleared your nickname.");
             return true;
         }
@@ -74,7 +74,7 @@ public class NicknameCommand extends ServerCommand
 
                 player.nickname = enteredNickname;
                 player.hadNicknameSet = true;
-                player.mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.score, player.chatColor, true, player.isOperator()));
+                player.mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator()));
                 sender.sendMessage("Set " + player.username + "'s nickname to " + player.getDisplayName());
                 handler.sendMessageToPlayer(player, "Your nickname was set to " + player.getDisplayName());
                 return true;
@@ -90,7 +90,7 @@ public class NicknameCommand extends ServerCommand
                 if (args.length != 2) return false;
                 player.nickname = "";
                 player.hadNicknameSet = true;
-                player.mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.score, player.chatColor, true, player.isOperator()));
+                player.mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator()));
                 sender.sendMessage("Cleared " + player.username + "'s nickname.");
                 handler.sendMessageToPlayer(player, "Your nickname was cleared.");
                 return true;
diff --git a/src/main/java/net/minecraft/core/net/command/servercommands/OpCommand.java b/src/main/java/net/minecraft/core/net/command/servercommands/OpCommand.java
index 026b6c8f8..731c07846 100644
--- a/src/main/java/net/minecraft/core/net/command/servercommands/OpCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/servercommands/OpCommand.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.net.command.servercommands;
 
+import net.minecraft.core.util.helper.UUIDHelper;
 import net.minecraft.server.MinecraftServer;
 import net.minecraft.server.entity.player.ServerPlayer;
 import net.minecraft.core.net.packet.UpdatePlayerProfilePacket;
@@ -18,16 +19,22 @@ public class OpCommand extends ServerCommand{
 	public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
 		if(args.length == 0) return false;
 		String name = args[0];
-		
-		server.playerList.opPlayer(name);
-		handler.sendCommandFeedback(sender, "Opping "+name);
-		
+
 		ServerPlayer player = (ServerPlayer) handler.getPlayer(name);
 		if(player != null) {
+			server.playerList.opPlayer(player.uuid);
+			handler.sendCommandFeedback(sender, "Opping "+name);
+
 			handler.sendMessageToPlayer(player, TextFormatting.YELLOW + "You are now op!");
-			player.mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.score, player.chatColor, true, player.isOperator()));
+			player.mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator()));
+		} else {
+			UUIDHelper.runConversionAction(name, (uuid) -> {
+				server.playerList.opPlayer(uuid);
+				handler.sendCommandFeedback(sender, "Opping "+name);
+			}, (username) -> handler.sendCommandFeedback(sender,"Could not retrieve UUID of player '" + username + "'"));
 		}
 
+
 		return true;
 	}
 
diff --git a/src/main/java/net/minecraft/core/net/command/servercommands/PardonCommand.java b/src/main/java/net/minecraft/core/net/command/servercommands/PardonCommand.java
index b15372123..39a15a414 100644
--- a/src/main/java/net/minecraft/core/net/command/servercommands/PardonCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/servercommands/PardonCommand.java
@@ -3,7 +3,9 @@ package net.minecraft.core.net.command.servercommands;
 import net.minecraft.core.net.command.CommandHandler;
 import net.minecraft.core.net.command.CommandSender;
 import net.minecraft.core.net.command.ServerCommand;
+import net.minecraft.core.util.helper.UUIDHelper;
 import net.minecraft.server.MinecraftServer;
+import net.minecraft.server.entity.player.ServerPlayer;
 
 public class PardonCommand extends ServerCommand {
     public PardonCommand(MinecraftServer server) {
@@ -17,8 +19,16 @@ public class PardonCommand extends ServerCommand {
 
         String nameToPardon = args[0];
 
-        server.playerList.pardonPlayer(nameToPardon);
-        sendNoticeToOps(senderName, "Pardoning " + nameToPardon);
+        ServerPlayer player = server.playerList.getPlayerEntity(nameToPardon);
+        if(player != null) {
+            server.playerList.pardonPlayer(player.uuid);
+            sendNoticeToOps(senderName, "Pardoning " + nameToPardon);
+        } else {
+            UUIDHelper.runConversionAction(nameToPardon, (uuid) -> {
+                server.playerList.pardonPlayer(uuid);
+                sendNoticeToOps(senderName, "Pardoning " + nameToPardon);
+            }, (username) -> handler.sendCommandFeedback(sender,"Could not retrieve UUID of player '" + username + "'"));
+        }
 
         return true;
     }
